﻿' Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

Module Module1

    Sub Main()
        Dim launcher = New RocketLauncher.Launcher()
        Try
            launcher.LaunchRocket()
        Catch ex As Exception When IsFuseLit(launcher)
            Console.WriteLine("VB-Houston: Something went wrong launching the rocket. Fuse is lit! Or is it? Who knows...")
        End Try

        Console.WriteLine("---------------------------------")
        Try
            launcher.AlternativeLaunchRocket()
        Catch ex As Exception When IsFuseLit(launcher)
            Console.WriteLine("VB-Houston: Something went wrong launching the rocket. Fuse is lit! Or is it?")
        Catch ex As Exception
            Console.WriteLine("VB-Houston: Something went wrong launching the rocket. Fuse definitely not lit now.")
        End Try
    End Sub

    Private Function IsFuseLit(ByVal launcher As RocketLauncher.Launcher) As Boolean
        Console.WriteLine("Checking whether fuse is lit...")
        Dim result = launcher.State = RocketLauncher.LaunchState.FuseLit
        If result Then
            Console.WriteLine("   Holy cow!")
        End If
        Return result
    End Function
End Module
