// Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Runtime.Serialization;

namespace CatchingAllTheTime {
  [Serializable]
  public class ConfigLoadException : Exception {
    public ConfigLoadException( ) { }
    public ConfigLoadException(string message) : base(message) { }
    public ConfigLoadException(string message, Exception innerException) : base(message, innerException) { }
    protected ConfigLoadException(SerializationInfo info, StreamingContext context) : base(info, context) { }
  }
}
